package checkers.quals;

import static java.lang.annotation.ElementType.ANNOTATION_TYPE;

import java.lang.annotation.*;

/**
 * Indicates that the annotated qualifier is the default qualifier in the
 * qualifier hierarchy.
 *
 * This default options can be overrided in the annotated code using the
 * annotation {@link DefaultQualifier} which targets java code elements.
 *
 * Each type qualifier hierarchy may have at most one qualifier marked as
 * {@code DefaultQualifierInHierarchy}.
 *
 * @see checkers.quals.DefaultQualifier
 */
@Documented
@Retention(RetentionPolicy.RUNTIME)
@Target(ANNOTATION_TYPE)
public @interface DefaultQualifierInHierarchy {

}
